﻿using System;

using ParaInt = TypyOgólne.Para<int>;

namespace TypyOgólne
{
    static class Program
    {
        static void Drukuj<T>(this T[] tablica, string nagłówek)
        {
            Console.WriteLine(typeof(T).Name + " " + nagłówek);
            foreach (T element in tablica)
                Console.WriteLine(element.ToString());
        }

        static void Main(string[] args)
        {
            Random r = new Random();

            //int
            //Para<int>[] pi = new Para<int>[10];
            ParaInt[] pi = new ParaInt[10];
            for (int i = 0; i < pi.Length; i++)
                pi[i] = new Para<int>(r.Next(10), r.Next(10));
            pi.Drukuj("przed sortowaniem");
            Array.Sort(pi);
            pi.Drukuj("po sortowaniu");
            /*
            Console.WriteLine("Para<int> po sortowaniu");
            foreach (Para<int> para in pi)
                Console.WriteLine(para.ToString());
            */

            //double
            Para<double>[] pd = new Para<double>[10];
            for (int i = 0; i < pd.Length; i++)
                pd[i] = new Para<double>(10*r.NextDouble(), 10*r.NextDouble());
            Console.WriteLine("Para<double>");
            foreach (Para<double> para in pd)
                Console.WriteLine(para.ToString());
            Array.Sort(pd);
            Console.WriteLine("Para<double> po sortowaniu");
            foreach (Para<double> para in pd)
                Console.WriteLine(para.ToString());
        }
    }


    class Para<T> : IComparable<Para<T>> where T : IComparable<T>
    {
        private T pierwszy = default(T), drugi = default(T);

        public Para(T pierwszy, T drugi)
        {
            this.pierwszy = pierwszy;
            this.drugi = drugi;
        }

        public override string ToString()
        {
            return pierwszy.ToString() + "\t" + drugi.ToString();
        }

        public int CompareTo(Para<T> innaPara)
        {
            int wartość = pierwszy.CompareTo(innaPara.pierwszy);
            if (wartość != 0) return wartość;
            else return drugi.CompareTo(innaPara.drugi);
        }
    }
}
